"
 COPYRIGHT (c) 1995 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

DeviceHandle subclass:#DeviceViewHandle
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Graphics-Support'
!

!DeviceViewHandle class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1995 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    This is used as a finalization handle for views - in previous systems,
    a shallowCopy of a view was responsible to destroy the underlying
    devices view. To make the memory requirements smaller and to speed up
    view creation a bit, this lightweight class is used now, which only
    keeps the device handle for finalization.

    [see also:]
        DisplaySurface

    [author:]
        Claus Gittinger
"
! !

!DeviceViewHandle methodsFor:'finalization'!

disposed
    "the view for which I am a handle was collected 
     - release system resources"

    |v|

    drawableId notNil ifTrue:[
        gcId notNil ifTrue:[
            device destroyGC:gcId.
            gcId := nil.
        ].

        "/ care for lost-view trouble:
        "/ if the windowID is still registered,
        "/ this may be due to a not-yet-reclaimed
        "/ subview of a view which has already been destroyed
        "/ (X recycles window handles.)
        "/ In this case, we arrive here with a nil-view argument,
        "/ and a windowId, which is already reused for some other view.
        "/ The situation is detected by finding a non-nil (and non-zero)
        "/ view in the devices id<->view table for the given windowId.

        (device viewIdKnown:drawableId) ifTrue:[
"/ 'Display [info]: recycled view (' infoPrint. v infoPrint. ') not destroyed: ' infoPrint.
"/ drawableId displayString infoPrintCR.
            drawableId := nil.
        ] ifFalse:[
"/ 'GC destroy: ' print. drawableId displayString printCR.
"/ device checkKnownViewId:drawableId.
            device destroyView:nil withId:drawableId.
            drawableId := nil.
        ]
    ].

    "Modified: 4.4.1997 / 11:01:48 / cg"
! !

!DeviceViewHandle class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libview/Attic/DevViewH.st,v 1.13 1997-04-15 14:00:58 cg Exp $'
! !
